package com.sxc.etaxincome.controller;

import com.sxc.etaxincome.domain.command.report.IReportCommand;
import com.sxc.etaxincome.domain.model.common.CommonRequestWrapper;
import com.sxc.etaxincome.domain.model.common.CommonResponse;
import com.sxc.etaxincome.domain.model.report.IReportResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author caosongqing
 * @date 2024/4/24
 * @description
 */
@Slf4j
@RestController
@RequestMapping("/report")
public class ReportController {

    @Autowired
    @Qualifier(value = "generalTaxpayerReportCommand")
    private IReportCommand generalTaxpayerReportCommand;

    @PostMapping("/general-taxpayer")
    public CommonResponse<IReportResponse> reportGeneralTaxpayer(@Validated CommonRequestWrapper commonRequestWrapper) {
        return generalTaxpayerReportCommand.execute(commonRequestWrapper);
    }

    @PostMapping("/general-taxpayer/json")
    public CommonResponse<IReportResponse> reportGeneralTaxpayerJson(@Validated @RequestBody CommonRequestWrapper requestCommonWrapper) {
        return generalTaxpayerReportCommand.execute(requestCommonWrapper);
    }
}
