package com.sxc.etaxincome.domain.init;

import cn.hutool.http.HttpUtil;
import com.alibaba.nacos.api.config.annotation.NacosValue;
import com.sxc.etaxincome.domain.business.IVersionManager;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.Ordered;
import org.springframework.stereotype.Component;

/**
 * @author caosongqing
 * @date 2022/12/12
 * @description
 */
@Slf4j
@Component
public class SendVersionRunner implements CommandLineRunner, Ordered {

    @Autowired
    private IVersionManager versionService;

    @NacosValue(value = "${url.monitor.version}", autoRefreshed = true)
    private String sendVersionUrl;

    @NacosValue(value = "${send.version.enabled}", autoRefreshed = true)
    private boolean sendVersionEnabled;

    private void handle() {
        log.info("sendVersionEnabled:{}", sendVersionEnabled);
        if (sendVersionEnabled) {
            try {
                String response = HttpUtil.get(sendVersionUrl + "?version=" + versionService.version());
                log.info("start application send version response:{}", response);
            } catch (Exception e) {
                log.error("send version error:{}", e);
            }
        }
    }

    @Override
    public void run(String... args) throws Exception {
        handle();
    }

    @Override
    public int getOrder() {
        return 0;
    }
}
