package com.sxc.etaxincome.service.impl;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sxc.etaxincome.common.model.report.IncomeExceptionStatResult;
import com.sxc.etaxincome.criteria.FinRealLogCriteria;
import com.sxc.etaxincome.criteria.IncomeQueryCommon;
import com.sxc.etaxincome.entity.FinCountReport;
import com.sxc.etaxincome.entity.FinRealLog;
import com.sxc.etaxincome.mapper.FinRealLogMapper;
import com.sxc.etaxincome.service.IFinRealLogService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import java.util.List;

import static javax.management.Query.eq;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author mybatis-plus-generator
 * @since 2024-06-05 22:49:55
 */
@Service
public class FinRealLogServiceImpl extends ServiceImpl<FinRealLogMapper, FinRealLog> implements IFinRealLogService {

    @Override
    public List<FinCountReport> statAreaIncome(IncomeQueryCommon incomeQueryCommon) {
        return this.getBaseMapper().statAreaIncome(incomeQueryCommon);
    }

    @Override
    public List<IncomeExceptionStatResult> queryExceptionList(IncomeQueryCommon incomeQueryCommon) {
        return this.getBaseMapper().queryExceptionList(incomeQueryCommon);
    }

    @Override
    public IPage<FinRealLog> queryPageListOrderByRequestTimeDesc(FinRealLogCriteria finRealLogCriteria, int start, int limit) {

        Wrapper<FinRealLog> queryWrapper = Wrappers.<FinRealLog>lambdaQuery()
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getZoneCode()), FinRealLog::getZoneCode, finRealLogCriteria.getZoneCode())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getUserCode()), FinRealLog::getUserCode, finRealLogCriteria.getUserCode())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getResCode()), FinRealLog::getResCode, finRealLogCriteria.getResCode())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getTaxno()), FinRealLog::getTaxno, finRealLogCriteria.getTaxno())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getItype()), FinRealLog::getItype, finRealLogCriteria.getItype())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getReqSign()), FinRealLog::getReqSign, finRealLogCriteria.getReqSign())
                .eq(StringUtils.isNotBlank(finRealLogCriteria.getTimeFlag()), FinRealLog::getTimeFlag, finRealLogCriteria.getTimeFlag())
                .like(StringUtils.isNotBlank(finRealLogCriteria.getReqContext()), FinRealLog::getReqContext, finRealLogCriteria.getReqContext())
                .like(StringUtils.isNotBlank(finRealLogCriteria.getResContext()), FinRealLog::getResContext, finRealLogCriteria.getResContext())
                .like(StringUtils.isNotBlank(finRealLogCriteria.getResMsg()), FinRealLog::getResMsg, finRealLogCriteria.getResMsg())
                .between(FinRealLog::getReqDate, finRealLogCriteria.getDateTimeStart(), finRealLogCriteria.getDateTimeEnd())
                .ge(finRealLogCriteria.getStartTimeDiff() != null, FinRealLog::getTimeDiff, finRealLogCriteria.getStartTimeDiff())
                .le(finRealLogCriteria.getEndTimeDiff() != null, FinRealLog::getTimeDiff, finRealLogCriteria.getEndTimeDiff())
                .orderByDesc(true, FinRealLog::getReqDate);
        return this.page(new Page<>(start, limit), queryWrapper);
    }
}
